#pragma once

#include "ofMain.h"
#include "ofxMaxim.h"
#include "maximilian.h"




class Particle{
    
public:
    
    Particle();
    void setup();
    void update( float dt);
    void draw();
    
    ofPoint pos; // position of the point.
    ofPoint vel;
    float time;
    float lifeTime;
    bool live;
    
    float * fftSmooth; // calling the fft
    int bands;         // declaring the int bands 
    
    };

class Params {
    
public:
    void setup();
    ofPoint eCenter;
    float eRad;
    float velRad;
    float lifeTime; // lifetime in seconds
    float rotate;
    
    float force;  //direction of rotation speed
    float spinning;
    float friction;
    
    
};


extern Params param;   // global variable






class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);
        //void audioOut (float * output, int bufferSize, int nChannels);
        
    ofPoint drag;
    
    
    
    
    
    
    
    ofSoundPlayer song2;
    
    float * fftSmooth;
    int bands;
    
    
    
    vector<Particle> p;
    float bornRate;
    float bornCount;
    ofFbo fbo;
    float history;
    float time0;
};
